Package org.apache.sis.referencing.datum

# Class DefaultVerticalDatum

Object
FormattableObject
AbstractIdentifiedObject
AbstractDatum
DefaultVerticalDatum

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `Datum`, `VerticalDatum`, `IdentifiedObject`

public class DefaultVerticalDatum extends AbstractDatum implements VerticalDatum
Identifies a particular reference level surface used as a zero-height surface. There are several types of vertical datums, and each may place constraints on the coordinate system axis with which it is combined to create a vertical CRS.

## Creating new vertical datum instances

New instances can be created either directly by specifying all information to a factory method (choices 3 and 4 below), or indirectly by specifying the identifier of an entry in a database (choices 1 and 2 below). Choice 1 in the following list is the easiest but most restrictive way to get a vertical datum. The other choices provide more freedom.

1. Create a `VerticalDatum` from one of the static convenience shortcuts listed in `CommonCRS​.Vertical​.datum()`.
2. Create a `VerticalDatum` from an identifier in a database by invoking `DatumAuthorityFactory​.createVerticalDatum(String)`.
3. Create a `VerticalDatum` by invoking the `DatumFactory​.createVerticalDatum(…)` method (implemented for example by `GeodeticObjectFactory`).
4. Create a `DefaultVerticalDatum` by invoking the constructor.

Example: the following code gets a vertical datum for height above the geoid:

>     VerticalDatum datum = CommonCRS.Vertical.GEOID.datum();

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.4
See Also:
  - `CommonCRS​.Vertical​.datum()`
  - `DefaultVerticalCS`
  - `DefaultVerticalCRS`
  - `GeodeticAuthorityFactory​.createVerticalDatum(String)`
  - Serialized Form

Defined in the `sis-referencing` module

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface Datum

  `ANCHOR_POINT_KEY, DOMAIN_OF_VALIDITY_KEY, REALIZATION_EPOCH_KEY, SCOPE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultVerticalDatum(Map<String,?> properties, VerticalDatumType type)`
  Creates a vertical datum from the given properties.
  `protected`
  `DefaultVerticalDatum(VerticalDatum datum)`
  Creates a new datum with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultVerticalDatum`
  `castOrCopy(VerticalDatum object)`
  Returns a SIS datum implementation with the same values than the given arbitrary implementation.
  `protected long`
  `computeHashCode()`
  Invoked by `hashCode()` for computing the hash code when first needed.
  `boolean`
  `equals(Object object, ComparisonMode mode)`
  Compare this vertical datum with the specified object for equality.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this datum as a Well Known Text `VerticalDatum[…]` element.
  `Class<? extends VerticalDatum>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.
  `VerticalDatumType`
  `getVerticalDatumType()`
  Returns the type of this vertical datum.

  ### Methods inherited from class AbstractDatum

  `castOrCopy, getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope, isHeuristicMatchForName`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Datum

  `getAnchorPoint, getDomainOfValidity, getRealizationEpoch, getScope`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- ## Constructor Details

  - ### DefaultVerticalDatum

    public DefaultVerticalDatum(Map<String,?> properties, VerticalDatumType type)
    Creates a vertical datum from the given properties. The properties map is given unchanged to the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
    "anchorPoint" | `InternationalString` or `String` | `AbstractDatum.getAnchorPoint()`
    "realizationEpoch" | `Date` | `AbstractDatum.getRealizationEpoch()`
    "domainOfValidity" | `Extent` | `AbstractDatum.getDomainOfValidity()`
    "scope" | `InternationalString` or `String` | `AbstractDatum.getScope()`

    Parameters:
      `properties` - the properties to be given to the identified object.
      `type` - the type of this vertical datum.
    See Also:
      - `GeodeticObjectFactory​.createVerticalDatum(Map, VerticalDatumType)`

  - ### DefaultVerticalDatum

    protected DefaultVerticalDatum(VerticalDatum datum)
    Creates a new datum with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `datum` - the datum to copy.
    See Also:
      - `castOrCopy(VerticalDatum)`

- ## Method Details

  - ### castOrCopy

    public static DefaultVerticalDatum castOrCopy(VerticalDatum object)
    Returns a SIS datum implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends VerticalDatum> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `VerticalDatum​.class`.
    Note for implementers: Subclasses usually do not need to override this method since GeoAPI does not define `VerticalDatum` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Overrides:
      `getInterface` in class `AbstractDatum`
    Returns:
      `VerticalDatum​.class` or a user-defined sub-interface.

  - ### getVerticalDatumType

    public VerticalDatumType getVerticalDatumType()
    Returns the type of this vertical datum.
    Historical note: this property was defined in the ISO 19111 specification published in 2003, but removed from the revision published 2007. This property provides an information similar to the anchor definition, but in a programmatic way more suitable to coordinate transformation engines.
    Specified by:
      `getVerticalDatumType` in interface `VerticalDatum`
    Returns:
      the type of this vertical datum.

  - ### equals

    public boolean equals(Object object, ComparisonMode mode)
    Compare this vertical datum with the specified object for equality.
    Specified by:
      `equals` in interface `LenientComparable`
    Overrides:
      `equals` in class `AbstractDatum`
    Parameters:
      `object` - the object to compare to `this`.
      `mode` - `STRICT` for performing a strict comparison, or `IGNORE_METADATA` for comparing only properties relevant to coordinate transformations.
    Returns:
      `true` if both objects are equal.
    See Also:
      - `AbstractIdentifiedObject​.computeHashCode()`
      - `Utilities​.deepEquals(Object, Object, ComparisonMode)`

  - ### computeHashCode

    protected long computeHashCode()
    Invoked by `hashCode()` for computing the hash code when first needed. See `AbstractIdentifiedObject​.computeHashCode()` for more information.
    Overrides:
      `computeHashCode` in class `AbstractDatum`
    Returns:
      the hash code value. This value may change in any future Apache SIS version.

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this datum as a Well Known Text `VerticalDatum[…]` element.
    Compatibility note: OGC 01-009 defined numerical codes for various vertical datum types, for example 2005 for geoidal height and 2002 for ellipsoidal height. Such codes were formatted for all `Datum` subtypes in WKT 1. Datum types became provided only for vertical datum in the ISO 19111:2003 specification, then removed completely in ISO 19111:2007.
    Overrides:
      `formatTo` in class `AbstractDatum`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"VerticalDatum"` (WKT 2) or `"Vert_Datum"` (WKT 1).
    See Also:
      - WKT 2 specification §10.2